{

error handler
(c) 1995-2000 by raVen

supported compilers: borland pascal 7.x, virtual pascal 2.0b+

}
{&Use32+,LocInfo+}
{$D+,L+,I-,R-,S-,Q-}
{}
unit rError;
interface
{}
type
 tExitProc = procedure;
{}
const
{
 MemFucked - ࠧ ࠭ ணࠬ .
  vp2   ⤥쭮 thread ࠧ  55 (),  bp7  
 ⠩୮ 뢠 ਬ୮ ࠧ  55 (). 㦨  ⫮ 祪 .
}
 MemFucked: Longint = 0;
 LeakHunter: Boolean = True;
{}
 procedure AddExitProc(const aExitProc: tExitProc);
 procedure SetErrorLog(const aFileName: String);
 procedure UpdateFucked;
 procedure FixFucked;
 procedure PrintFucked;
{}
implementation
Uses
 rCommon, rStrings, Objects, rObjects, Dos, rTime
 {$IfDef VirtualPascal},VPUtils, VPSysLow{$EndIf};
{}
type
 pExitProcCollection = ^tExitProcCollection;
 tExitProcCollection = object(tCollection)
  procedure FreeItem(Item: Pointer); virtual;
 end;
{}
var
 ErrorLog: String;
 ExitAddress: Pointer;
 ExitProcCol: tExitProcCollection;
 FirstAvail: Longint;
{$IfDef Ver70}
 OldInt1Ch: Pointer;
{$EndIf}
{$IfDef VirtualPascal}
 UpdateTID: Longint;
{$EndIf}
 LeakBegin: Longint;
{}
procedure tExitProcCollection.FreeItem;
 begin
 end;
{}
procedure AddExitProc(const aExitproc: tExitProc);
 var
  x: Integer;
  p: Pointer absolute aExitProc;
 begin
  if (ExitProcCol.Count>0) then for x:=0 to ExitProcCol.Count-1 do
  if (p=ExitProcCol.At(x)) then exit;
  ExitProcCol.Insert(@aExitProc);
 end;
{}
procedure SetErrorLog(const aFileName: String);
 begin
  ErrorLog:=aFileName;
 end;
{}
{$F+}
procedure ErrorExit;
 var
  t: text;
  FileName: String;
  LineNo: Longint;
  x: Integer;
  p: Pointer;
  dt: DateTime;
 begin
  ExitProc:=ExitAddress;
  with (ExitProcCol) do if (Count>0) then for x:=0 to Count-1 do
   begin
    p:=At(x);
    tExitProc(p);
   end;
  if ErrorAddr<>nil then
   begin
    MkTree(ErrorLog);
    Assign(t,ErrorLog);
    Append(t);
    if (IOResult<>0) then Rewrite(t) else TextFileSeek(t,TextFileSize(t));
    GetCurrentTime(dt);
    WriteLn(t,#13#10'----- '+DateStr(dt)+', '+TimeStr(dt));
    Write(t,'hi, i''m excepted with error number ');
{$IfDef VirtualPascal}
    if GetLocationInfo(ErrorAddr,FileName,LineNo)<>nil then WriteLn(t,ExitCode,' in [',FileName,'] line #',LineNo,'.')
    else
{$EndIf}
    WriteLn(t,ExitCode,' at ', HexL(Longint(ErrorAddr)),'.');
    Write(t,'identifier: ');
    case ExitCode of
     001: WriteLn(t,'invalid function number.');
     002: WriteLn(t,'file not found.');
     003: WriteLn(t,'path not found.');
     004: WriteLn(t,'too many open files.');
     005: WriteLn(t,'file access denied.');
     006: WriteLn(t,'invalid file handle.');
     012: WriteLn(t,'invalid file access code.');
     015: WriteLn(t,'invalid drive number.');
     016: WriteLn(t,'cannot remove current directory.');
     017: WriteLn(t,'cannot rename across drives.');
     018: WriteLn(t,'no more files.');
     100: WriteLn(t,'disk read error.');
     101: WriteLn(t,'disk write error.');
     102: WriteLn(t,'file not assigned.');
     103: WriteLn(t,'file not open.');
     104: WriteLn(t,'file not open for input.');
     105: WriteLn(t,'file not open for output.');
     106: WriteLn(t,'invalid numeric format.');
     150: WriteLn(t,'disk is write-protected.');
     151: WriteLn(t,'unknown unit.');
     152: WriteLn(t,'drive not ready.');
     153: WriteLn(t,'unknown command.');
     154: WriteLn(t,'crc error in data.');
     155: WriteLn(t,'bad drive request structure length.');
     156: WriteLn(t,'disk seek error.');
     157: WriteLn(t,'unknown media type.');
     158: WriteLn(t,'sector not found.');
     159: WriteLn(t,'printer out of paper.');
     160: WriteLn(t,'device write fault.');
     161: WriteLn(t,'device read fault.');
     162: WriteLn(t,'hardware failure.');
     200: WriteLn(t,'division by zero.');
     201: WriteLn(t,'range check error.');
     202: WriteLn(t,'stack overflow error.');
     203: WriteLn(t,'heap overflow error.');
     204: WriteLn(t,'invalid pointer operation.');
     205: WriteLn(t,'floating point overflow.');
     206: WriteLn(t,'floating point underflow.');
     207: WriteLn(t,'invalid floating point operation.');
     208: WriteLn(t,'overlay manager not installed.');
     209: WriteLn(t,'overlay file read error.');
     210: WriteLn(t,'object not initialized.');
     211: WriteLn(t,'call to abstract method.');
     212: WriteLn(t,'stream registration error.');
     213: WriteLn(t,'collection index out of range.');
     214: WriteLn(t,'collection overflow error.');
     215: WriteLn(t,'arithmetic overflow error.');
     216: WriteLn(t,'general protection fault.');
     else WriteLn(t,'unknown error.');
    end;
    ErrorAddr:=nil;
    WriteLn(t,'backup your data and report to 2:550/428 or raven@fido.urc.ac.ru!');
    Close(t);
   end;
  ExitProcCol.Done;
{$IfDef Ver70}
  SetIntVec($1C,OldInt1Ch);
{$EndIf}
{$IfDef VirtualPascal}
  KillThread(UpdateTID);
{$EndIf}
 end;
{$F-}
{}
procedure FixFucked;
 begin
  UpDateFucked;
  LeakBegin:=MemFucked;
 end;
{}
procedure PrintFucked;
 var
  t: text;
  dt: DateTime;
 begin
  UpdateFucked;
  LeakBegin:=MemFucked-LeakBegin;
  if (LeakBegin<=0) then exit;
  Assign(t,ErrorLog);
  Append(t);
  if (IOResult<>0) then Rewrite(t) else TextFileSeek(t,TextFileSize(t));
  GetCurrentTime(dt);
  WriteLn(t,#13#10'----- '+DateStr(dt)+', '+TimeStr(dt));
  WriteLn(t,'memory leak is ',LeakBegin,' byte(s).');
  Close(t);
 end;
{}
{$IfDef VirtualPascal}
function UpDateMemUsed(p: Pointer): Longint;
 begin
  repeat
   MemFucked:=MemUsed-FirstAvail;
   SysCtrlSleep(55);
  until false;
 end;
{$EndIf}
{$IfDef Ver70}
procedure UpDateMemFucked; interrupt;
 begin
  MemFucked:=FirstAvail-MemAvail;
{  inline($9C);
  asm call OldInt1Ch end;}
 end;
{$EndIf}
{}
procedure UpdateFucked;
 begin
 {$IfDef VirtualPascal}
  MemFucked:=MemUsed-FirstAvail;
 {$EndIf}
 {$IfDef Ver70}
  MemFucked:=FirstAvail-MemAvail;
 {$EndIf}
 end;
{}
begin
 ErrorLog:='';
 ExitProcCol.Init(16,16);
 ExitAddress:=ExitProc;
 ExitProc:=@ErrorExit;
{$IfDef Ver70}
 FirstAvail:=MemAvail;
 GetIntVec($1C,OldInt1Ch);
 SetIntVec($1C,@UpDateMemFucked);
{$EndIf}
{$IfDef VirtualPascal}
 FirstAvail:=MemUsed;
 UpDateTid:=VPBeginThread(UpDateMemUsed,1024,nil);
{$EndIf}
 UpdateFucked;
 LeakBegin:=MemFucked;
end.
